stages:
  - build
  - test
  - quality
  - deploy

variables:
  CONTAINER_IMAGE: "${CI_REGISTRY_IMAGE}:${CI_COMMIT_REF_NAME}"

build:
  stage: build
  tags:
    - docker-build
  script:
    - docker login -u "gitlab-ci-token" -p "$CI_JOB_TOKEN" $CI_REGISTRY
    - docker build --pull -t ${CONTAINER_IMAGE} .
    - docker push ${CONTAINER_IMAGE}

unit_test:
  stage: test
  image : "$CONTAINER_IMAGE"
  variables:
    XDEBUG_ON: "true"
    XDEBUG_MODE: "coverage"
  script:
    - cd /app/
    - make coverage
    - cp -rf coverage $CI_PROJECT_DIR
  artifacts:
    paths:
      - coverage
    expire_in: 1h

quality:
  stage: quality
  only:
    - master
  image : gitlab.libriciel.fr:4567/docker/sonar-scanner:latest
  script:
    - mkdir -p /app/
    - cp -rf $CI_PROJECT_DIR/* /app/
    - cd /app/
    - /sonar-scanner -Dsonar.login=$SONAR_LOGIN -Dsonar.host.url=$SONAR_HOST_URL

run_another_pipeline:
    stage: deploy
    only:
        - master
    script:
        - curl --request POST --form "token=$PIPELINE_TRIGGER_TOKEN" --form ref=master https://gitlab.libriciel.fr/api/v4/projects/816/trigger/pipeline
